回溯-LeetCode39. 组合总和

12 篇文章 0 订阅

1、题目描述

https://leetcode-cn.com/problems/combination-sum/

给定一个无重复元素的数组 candidates 和一个目标数 target ,找出 candidates 中所有可以使数字和为 target 的组合。

  • candidates 中的数字可以无限制重复被选取。
  • 所有数字(包括 target)都是正整数。 解集不能包含重复的组合。
输入:candidates = [2,3,6,7], target = 7,
所求解集为:
[[7],
 [2,2,3]]

输入:candidates = [2,3,5], target = 8,
所求解集为:
[[2,2,2,2],
 [2,3,3],
 [3,5]]
  • 1 <= candidates.length <= 30
  • 1 <= candidates[i] <= 200
  • candidate 中的每个元素都是独一无二的。
  • 1 <= target <= 500

2、代码详解

https://leetcode-cn.com/problems/combination-sum/solution/hui-su-jian-zhi-jian-zhi-hou-9394zhu-xing-jie-shi-/

写法一:target从target不断减到0

class Solution:
    def combinationSum(self, candidates, target):
        if not candidates:
            return []
        n = len(candidates)
        res = []
        candidates.sort()

        def helper(i, tmp, target):  # 下一加和索引i,当前已加和数组tmp,下一目标target(不断减)
            # 若target==0(target减后为0),说明当前和满足条件,将当前加和数组tmp加入res,并return
            if target == 0:
                res.append(tmp)
                return
            # 剪枝 因为已经将candidates排序,所以当下一目标小于下一待加和数时,return。
            # 并且当下一待加和索引i==n时,return。
            # 为了防止数组越界,将条件i==n放在target<candidates[i]之前,进行截断。
            if i == n or target < candidates[i]:
                return

            helper(i, tmp + [candidates[i]], target - candidates[i])  # 因为可重复调用元素,继续重复调用自身。
            helper(i + 1, tmp, target)  # 调用数组中下一元素,寻找新答案

        helper(0, [], target)
        return res

同类写法二:tmp_sum从0加到target

class Solution:
    def combinationSum(self, candidates, target):
        candidates.sort()
        n = len(candidates)
        res = []
        def helper(i, tmp, tmp_sum):
            if tmp_sum > target or i == n:
                return 
            if tmp_sum == target:
                res.append(tmp)
                return 
            helper(i, tmp + [candidates[i]], tmp_sum + candidates[i])
            helper(i+1, tmp, tmp_sum)
        helper(0, [], 0)
        return res

https://leetcode-cn.com/problems/combination-sum/solution/xue-yi-tao-zou-tian-xia-hui-su-suan-fa-by-powcai/

  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
好的,下面是电话号码的字母组合问题的 C++ 代码实现: ``` class Solution { public: vector<string> letterCombinations(string digits) { unordered_map<char, string> mapping = { {&#39;2&#39;, "abc"}, {&#39;3&#39;, "def"}, {&#39;4&#39;, "ghi"}, {&#39;5&#39;, "jkl"}, {&#39;6&#39;, "mno"}, {&#39;7&#39;, "pqrs"}, {&#39;8&#39;, "tuv"}, {&#39;9&#39;, "wxyz"} }; vector<string> res; if (digits.empty()) { return res; } string combination; backtrack(res, combination, digits, 0, mapping); return res; } void backtrack(vector<string>& res, string& combination, string& digits, int index, unordered_map<char, string>& mapping) { if (index == digits.size()) { res.push_back(combination); return; } for (char c : mapping[digits[index]]) { combination.push_back(c); backtrack(res, combination, digits, index + 1, mapping); combination.pop_back(); } } }; ``` 其中 `letterCombinations` 函数用来生成所有的字母组合,`backtrack` 函数用来进行回溯操作。在 `letterCombinations` 函数中,首先根据数字字符和字母的映射关系创建了一个 `unordered_map` 对象 `mapping`。然后定义了一个空字符串 `combination` 和一个空 vector `res` 来保存最终结果。最后调用了 `backtrack` 函数来生成所有的字母组合。在 `backtrack` 函数中,首先判断是否达到了数字字符串的末尾,如果是,则将当前的 `combination` 字符串保存到 `res` 中。否则,遍历当前数字字符所能表示的所有字母,依次加入到 `combination` 字符串中,然后递归调用 `backtrack` 函数,添加下一个数字字符所能表示的字母。递归完成后,需要将 `combination` 字符串还原到上一个状态,以便进行下一次回溯。最终返回 `res` 数组即可。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值